#!/usr/local/bin/python

#Copyright (C) 2004  by Phillip Deneault <deneault@hiddengroup.net>
#    This file is part of Placid.

#    Placid is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.

#    Placid is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with Placid; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import sys              #system module
import string           #string module
import MySQLdb
import MySQLdb.cursors
import time

def printheader():

	print "Content-Type: text/html\n\n"  #reports a web page
	print "<html>\n"
	print "<head><title>Placid</title></head>\n"
	print "<body bgcolor=\"ffffff\">\n"
        print "<table border=0 width=100%><tr><td><b><font size=+2>Placid 2.0</font></b> by Phil Deneault at <a href=\"mailto:deneault@hiddengroup.net?subject=Placid Topic\">deneault@hiddengroup.net</a></td>" 
        print "<td><a href=\"placid.py\">[ Home ]</a><nobr><nobr><a href=\"search.py\">[ Search ]</a><nobr><nobr><!--<a href=\"delete.py\">[ Delete ]</a>--></td>"
        print "</tr></table>\n"

def printtail():
	print "</body>\n"
	print "</html>\n"

def qrynumsensors():
	
	global db

	cur=db.cursor(MySQLdb.cursors.DictCursor)
	query = "select count(*) from sensor where last_cid != 0;"
	cur.execute(query)
	temp = cur.fetchone()
	return str(temp["count(*)"])

def qrynumevents():
	
	global db

	cur=db.cursor(MySQLdb.cursors.DictCursor)
	query = "select count(*) from event"
	cur.execute(query)
	temp = cur.fetchone()
	return str(temp["count(*)"])

def qryminmaxtime():
	
	global db

	cur=db.cursor()
	query = "select min(timestamp) from event;"
	cur.execute(query)
	temp = cur.fetchone()
	query = "select max(timestamp) from event;"
	cur.execute(query)
	temp1 = cur.fetchone()
	return str(temp[0]) + " - " + str(temp1[0])
	

def main():

	printheader()

	options = {}

	fin = open("./placid.cfg")
	line = fin.readline()
	while line:
		if line[0] != "#":
			tmp = string.split(line, "=")
			options[tmp[0]] = string.strip(tmp[1])
		line = fin.readline()
	fin.close()
	
	global db
	db = MySQLdb.connect(host=options['dbhost'],db=options['db'],passwd=options['passwd'],user=options['user'])

	print "<table border=0>"

	print "<tr><td>",	
	print "Num of Sensors with Signatures",
	print "</td><td align=center>",
	print qrynumsensors(),
	print "</td></tr>"

	print "<tr><td>",	
	print "Num of Events in Database",
	print "</td><td align=center>",
	print qrynumevents(),
	print "</td></tr>"

        print "<tr><td>",
        print "Time Window",
        print "</td><td align=center>",
        print qryminmaxtime(),
        print "</td></tr>"

        print "<tr><td>",
        print "Queried On",
        print "</td><td align=center>",
        print time.ctime(time.time()),
        print "</td></tr>"
	print "</table>"

	print "<br><BR>"

	print "<a href=\"search.py\">search page</a><br>"
	print "<a href=\"summary.py?timebefore=900&groupby=signatures&sortby=total\">last 15 minutes of alerts - sorted by total number unqiue alerts</a><br>"
	print "<a href=\"summary.py?timebefore=3600&groupby=signatures&sortby=total\">last 1 hour of alerts - sorted by total number unqiue alerts</a><br>"
	print "<a href=\"summary.py?timebefore=86400&groupby=signatures&sortby=total\">last 24 hour alerts - sorted by total number unqiue alerts</a><br>"
	print "<a href=\"summary.py?timebefore=86400&groupby=signatures\">last 24 hour alerts - sorted by unqiue alerts</a><br>"	
	print "<a href=\"summary.py?timebefore=259200&groupby=signatures\">last 72 hour alerts - sorted by unique alerts</a><br>" 
	print "<a href=\"summary.py?sortby=timestamp&numgroups=15&groupby=signatures\">most recent 15 alerts</a><br>"
	print "<a href=\"summary.py?sortby=total&numgroups=5&groupby=signatures\">Most frequent 5 alerts</a><br>"	
	print "<a href=\"summary.py?sortby=events&groupby=sensor\">Available Sensors</a><br>"

	printtail()	
	
main()
